/******************************************************************************/
/* @file  startup.s                                                           */
/* @brief  Startup assembler code.                                            */
/*                                                                            */
/* @details  Startup assembler code.                                          */
/*                                                                            */
/* @note  nothing.                                                            */
/*                                                                            */
/* @attention                                                                 */
/* Copyright (C) 2013-2019 MACNICA,Inc. All Rights Reserved.                  */
/*  This software is licensed "AS IS".                                        */
/*  Please perform use of this software by a user's own responsibility and    */
/*  expense.                                                                  */
/*  It cannot guarantee in the maker side about the damage which occurred by  */
/*  the ability not to use or use this software, and all damage that occurred */
/*  secondarily                                                               */
/******************************************************************************/
.global __reset

.text

__reset:
	mrs	r0, cpsr		/* Interrupt disable */
	orr	r0, r0, #0xC0	/* Interrupt disable */
	msr	cpsr_cxsf,r0	/* Interrupt disable */

	mrc	p15,0,r0,c1,c0,2	/* read CPACR */
	orr	r0,r0,#0x00f00000	/* Enable NEON/VFP user access */
	mcr	p15,0,r0,c1,c0,2	/* Write to CPACR */
	isb
	mov	r0,#0x40000000		/* Enable VFP/NEON Hardware */
	mcr	p10, 7, r0, cr8, cr0, 0	/* Write to fpexc */

	b _start
